
#include <iostream>
#include <gtest/gtest.h>
#include "hw/cpu.h"

using namespace std;

/*
 * main class
 */

#define LOWBATTERY "LowBattery"

struct hw_info *info;
struct cpu_device *cpu_dev;

class CPUHalTest : public testing::Test
{
	public:
		virtual void SetUp()
		{

		}

		virtual void TearDown()
		{

		}
};

/*
 * testcase
 */
TEST_F(CPUHalTest, InitP)
{
	int ret;

	ret = hw_get_info(CPU_HARDWARE_DEVICE_ID,
			(const struct hw_info **)&info);
	if (ret < 0) {
		cout << "There is no device for cpu " << ret << endl;
		return;
	} else {
		EXPECT_EQ(ret, 0) << "Fail to load cpu hal (" << ret << ")";
	}
	if (!info || !info->open) {
		cout << "There is no function for info open" << endl;
		return;
	}
	ret = info->open(info, NULL, (struct hw_common**)&cpu_dev);
	EXPECT_EQ(ret, 0) << "Fail to open cpu device (" << ret << ")";
}

TEST_F(CPUHalTest, StartBoostP)
{
	int ret;

	if (!cpu_dev || !cpu_dev->start_boost) {
		cout << "There is no function for start_boost" << endl;
		return;
	}

	// prprpr TODO
	ret = cpu_dev->start_boost((void *)LOWBATTERY);
	EXPECT_EQ(ret, 0) << "Fail to start_boost (" << ret << ")";
}

TEST_F(CPUHalTest, StopBoostP)
{
	int ret;

	if (!cpu_dev || !cpu_dev->stop_boost) {
		cout << "There is no function for stop_boost" << endl;
		return;
	}

	// prprpr TODO
	ret = cpu_dev->stop_boost((void *)LOWBATTERY);
	EXPECT_EQ(ret, 0) << "Fail to stop_boost (" << ret << ")";
}

TEST_F(CPUHalTest, DeinitP)
{
	int ret;

	if (!info || !info->close) {
		cout << "There is no function for info close" << endl;
		return;
	}

	ret = info->close((struct hw_common *)cpu_dev);
	EXPECT_EQ(ret, 0) << "Fail to open cpu device (" << ret << ")";
}

int main(int argc, char **argv)
{
	testing::InitGoogleTest(&argc, argv);

	return RUN_ALL_TESTS();
}
